/*
FILE: main_changes.cpp
DESCRIPTION: Test file demonstrating the usage of the PS2Pad library.
             Specifically, the ability to track button CHANGES is shown.
WRITTEN BY: Derek Nedelman (nedelman@netzero.net)
DATE: August 12, 2002
HOME PAGE: http://www.playstation2-linux.com/projects/joypadlib 
*/

#include <stdio.h>
#include "PS2Pad.h"

int main(int argc, char** argv)
{
	PS2Pad* joypad;
	
	PS2PadManager::Initialize();
	joypad = PS2PadManager::GetPad(0);

	puts("Press anything on the joypad to see button CHANGES.");
	puts("Press the START button to exit.");
	
	for (;;) 
	{
		PS2PadManager::Update();
		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_LEFT))
		{
			printf("Pressed left. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_LEFT), joypad->GetVelocity(PS2Pad::BUTTON_LEFT));
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_LEFT))
		{
			printf("Released left. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_LEFT), joypad->GetVelocity(PS2Pad::BUTTON_LEFT));
		}
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_UP))
		{
			printf("Pressed up. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_UP), joypad->GetVelocity(PS2Pad::BUTTON_UP));
		}		
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_UP))
		{
			printf("Released up. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_UP), joypad->GetVelocity(PS2Pad::BUTTON_UP));
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_RIGHT))
		{
			printf("Pressed right. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_RIGHT), joypad->GetVelocity(PS2Pad::BUTTON_RIGHT));
		}		
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_RIGHT))
		{
			printf("Released right. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_RIGHT), joypad->GetVelocity(PS2Pad::BUTTON_RIGHT));
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_DOWN))
		{
			printf("Pressed down. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_DOWN), joypad->GetVelocity(PS2Pad::BUTTON_DOWN));
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_DOWN))
		{
			printf("Released down. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_DOWN), joypad->GetVelocity(PS2Pad::BUTTON_DOWN));
		}
		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_L1))
		{
			printf("Pressed L1. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_L1), joypad->GetVelocity(PS2Pad::BUTTON_L1));
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_L1))
		{
			printf("Released L1. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_L1), joypad->GetVelocity(PS2Pad::BUTTON_L1));
		}
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_L2))
		{
			printf("Pressed L2. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_L2), joypad->GetVelocity(PS2Pad::BUTTON_L2));
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_L2))
		{
			printf("Released L2. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_L2), joypad->GetVelocity(PS2Pad::BUTTON_L2));
		}
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_L3))
		{
			puts("Pressed L3");
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_L3))
		{
			puts("Released L3");
		}
		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_R1))
		{
			printf("Pressed R1. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_R1), joypad->GetVelocity(PS2Pad::BUTTON_R1));
		}		
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_R1))
		{
			printf("Released R1. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_R1), joypad->GetVelocity(PS2Pad::BUTTON_R1));
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_R2))
		{
			printf("Pressed R2. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_R2), joypad->GetVelocity(PS2Pad::BUTTON_R2));
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_R2))
		{
			printf("Released R2. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_R2), joypad->GetVelocity(PS2Pad::BUTTON_R2));
		}
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_R3))
		{
			puts("Pressed R3");
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_R3))
		{
			puts("Released R3");
		}
		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_START))
		{
			puts("Pressed start");
			break;
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_SELECT))
		{
			puts("Pressed select");
		}
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_SELECT))
		{
			puts("Released select");
		}
		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_TRIANGLE))
		{
			printf("Pressed triangle. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_TRIANGLE), joypad->GetVelocity(PS2Pad::BUTTON_TRIANGLE));
		}		
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_TRIANGLE))
		{
			printf("Released triangle. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_TRIANGLE), joypad->GetVelocity(PS2Pad::BUTTON_TRIANGLE));
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_CIRCLE))
		{			
			printf("Pressed circle. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_CIRCLE), joypad->GetVelocity(PS2Pad::BUTTON_CIRCLE));
		}		
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_CIRCLE))
		{			
			printf("Released circle. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_CIRCLE), joypad->GetVelocity(PS2Pad::BUTTON_CIRCLE));
		}		
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_SQUARE))
		{
			printf("Pressed square. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_SQUARE), joypad->GetVelocity(PS2Pad::BUTTON_SQUARE));
		} 
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_SQUARE))
		{
			printf("Released square. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_SQUARE), joypad->GetVelocity(PS2Pad::BUTTON_SQUARE));
		} 
		if (joypad->WasButtonPressed(PS2Pad::BUTTON_CROSS))
		{
			printf("Pressed cross. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_CROSS), joypad->GetVelocity(PS2Pad::BUTTON_CROSS));
		}	
		else if (joypad->WasButtonReleased(PS2Pad::BUTTON_CROSS))
		{
			printf("Released cross. Pressure: %f. Velocity: %f\n", joypad->GetPressure(PS2Pad::BUTTON_CROSS), joypad->GetVelocity(PS2Pad::BUTTON_CROSS));
		}	

		if ((joypad->GetLeftX() != 0.0f) || (joypad->GetLeftY() != 0.0f))
		{
			printf("Left stick x/y: %f %f\n", joypad->GetLeftX(), joypad->GetLeftY());
		}

		if ((joypad->GetRightX() != 0.0f) || (joypad->GetRightY() != 0.0f))
		{
			printf("Right stick x/y: %f %f\n", joypad->GetRightX(), joypad->GetRightY());
		}		
	}
	
	PS2PadManager::Shutdown();
	return 0;
}
